#include "header.h"
CBigNumber num1(0xEBFF65432F2FFFF1, 0x0FFFFFFFFF2FFFF0);
CBigNumber num2(10,23);
CBigNumber numone(1);
CBigNumber diff = num1.diff(num2);
uint64_t* first=num1.getter();
uint64_t* second=num2.getter();
uint64_t* one=numone.getter();
TEST(CBigNumber, StoringChangingAndGetting) {
    EXPECT_EQ(second[0],10);
    EXPECT_EQ(second[1],23);
    EXPECT_EQ(one[1],1);
    numone.setter(2);
    delete one;
    one=numone.getter();
    EXPECT_EQ(one[1],2);
    EXPECT_EQ(first[0],0xEBFF65432F2FFFF1);
    EXPECT_EQ(first[1],0x0FFFFFFFFF2FFFF0);
    delete one;
}
TEST(CBigNumber, summing) {
    CBigNumber sum=num1.add(num2);
    uint64_t* sumreal=sum.getter();
    EXPECT_EQ(sumreal[0],0xebff65432f2ffffb);
    EXPECT_EQ(sumreal[1],0x0fffffffff300007);
    sum=num1.add(numone);
    sumreal=sum.getter();
    EXPECT_EQ(sumreal[0],0xebff65432f2ffff1);
    EXPECT_EQ(sumreal[1],0x0fffffffff2ffff2);
    delete sumreal;
}
TEST(CBigNumber, diffing) {CBigNumber sum=num1.diff(num2);uint64_t* sumreal=sum.getter();
    EXPECT_EQ(sumreal[0],0xebff65432f2fffe7);
    EXPECT_EQ(sumreal[1],0x0fffffffff2fffd9);
    delete sumreal;}
int main() {
    std::cout<<"Cool output: 0x";num1.printhex();std::cout<<std::endl
             <<"Cool output smaller: 0x";num2.printhex();std::cout<<std::endl
             <<"Cool output tiny: 0x";numone.printhex();std::cout<<std::endl;
    
testing::InitGoogleTest();
return RUN_ALL_TESTS();
}
